Line with Drilldown in JavaScript

Using ApexCharts with JavaScript

This Line with Drilldown example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      name: 'Resolved',
      data: [
        { x: '2021', y: 486 },
        { x: '2022', y: 702 },
        { x: '2023', y: 1012, drilldown: 'y2023' },
        { x: '2024', y: 1421, drilldown: 'y2024' },
        { x: '2025', y: 1866, drilldown: 'y2025' },
      ],
    },
  ],
  chart: {
    height: 380,
    type: 'line',
    toolbar: {
      show: false,
    },
  },
  drilldown: {
    enabled: true,
    breadcrumb: {
      show: true,
      rootLabel: 'All years',
    },
    series: [
      {
        id: 'y2023',
        name: '2023 by quarter',
        data: [
          { x: 'Q1', y: 214, drilldown: 'y2023-q1' },
          { x: 'Q2', y: 238 },
          { x: 'Q3', y: 259 },
          { x: 'Q4', y: 301 },
        ],
      },
      {
        id: 'y2023-q1',
        name: 'Q1 2023 by month',
        data: [
          { x: 'Jan', y: 66 },
          { x: 'Feb', y: 70 },
          { x: 'Mar', y: 78 },
        ],
      },
      {
        id: 'y2024',
        name: '2024 by quarter',
        data: [
          { x: 'Q1', y: 322 },
          { x: 'Q2', y: 356 },
          { x: 'Q3', y: 341 },
          { x: 'Q4', y: 402 },
        ],
      },
      {
        id: 'y2025',
        name: '2025 by quarter',
        data: [
          { x: 'Q1', y: 428 },
          { x: 'Q2', y: 455 },
          { x: 'Q3', y: 471 },
          { x: 'Q4', y: 512 },
        ],
      },
    ],
  },
  colors: ['#008FFB'],
  stroke: {
    width: 3,
    curve: 'smooth',
  },
  title: {
    text: 'Support tickets resolved',
    align: 'left',
  },
  subtitle: {
    text: 'Dotted points open a level: 2023, 2024 and 2025 break down by quarter.',
    align: 'left',
  },
  grid: {
    borderColor: '#e7e7e7',
  },
  yaxis: {
    title: {
      text: 'Tickets (thousands)',
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Line with Drilldown in Angular

Using ApexCharts with Angular

This Line with Drilldown example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Resolved',
              data: [
                { x: '2021', y: 486 },
                { x: '2022', y: 702 },
                { x: '2023', y: 1012, drilldown: 'y2023' },
                { x: '2024', y: 1421, drilldown: 'y2024' },
                { x: '2025', y: 1866, drilldown: 'y2025' },
              ],
            },
          ],
          chart: {
            height: 380,
            type: 'line',
            toolbar: {
              show: false,
            },
          },
          drilldown: {
            enabled: true,
            breadcrumb: {
              show: true,
              rootLabel: 'All years',
            },
            series: [
              {
                id: 'y2023',
                name: '2023 by quarter',
                data: [
                  { x: 'Q1', y: 214, drilldown: 'y2023-q1' },
                  { x: 'Q2', y: 238 },
                  { x: 'Q3', y: 259 },
                  { x: 'Q4', y: 301 },
                ],
              },
              {
                id: 'y2023-q1',
                name: 'Q1 2023 by month',
                data: [
                  { x: 'Jan', y: 66 },
                  { x: 'Feb', y: 70 },
                  { x: 'Mar', y: 78 },
                ],
              },
              {
                id: 'y2024',
                name: '2024 by quarter',
                data: [
                  { x: 'Q1', y: 322 },
                  { x: 'Q2', y: 356 },
                  { x: 'Q3', y: 341 },
                  { x: 'Q4', y: 402 },
                ],
              },
              {
                id: 'y2025',
                name: '2025 by quarter',
                data: [
                  { x: 'Q1', y: 428 },
                  { x: 'Q2', y: 455 },
                  { x: 'Q3', y: 471 },
                  { x: 'Q4', y: 512 },
                ],
              },
            ],
          },
          colors: ['#008FFB'],
          stroke: {
            width: 3,
            curve: 'smooth',
          },
          title: {
            text: 'Support tickets resolved',
            align: 'left',
          },
          subtitle: {
            text: 'Dotted points open a level: 2023, 2024 and 2025 break down by quarter.',
            align: 'left',
          },
          grid: {
            borderColor: '#e7e7e7',
          },
          yaxis: {
            title: {
              text: 'Tickets (thousands)',
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Line with Drilldown in React

Using ApexCharts with React

This Line with Drilldown example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Resolved',
        data: [
          { x: '2021', y: 486 },
          { x: '2022', y: 702 },
          { x: '2023', y: 1012, drilldown: 'y2023' },
          { x: '2024', y: 1421, drilldown: 'y2024' },
          { x: '2025', y: 1866, drilldown: 'y2025' },
        ],
      },
    ],
    options: {
      chart: {
        height: 380,
        type: 'line',
        toolbar: {
          show: false,
        },
      },
      drilldown: {
        enabled: true,
        breadcrumb: {
          show: true,
          rootLabel: 'All years',
        },
        series: [
          {
            id: 'y2023',
            name: '2023 by quarter',
            data: [
              { x: 'Q1', y: 214, drilldown: 'y2023-q1' },
              { x: 'Q2', y: 238 },
              { x: 'Q3', y: 259 },
              { x: 'Q4', y: 301 },
            ],
          },
          {
            id: 'y2023-q1',
            name: 'Q1 2023 by month',
            data: [
              { x: 'Jan', y: 66 },
              { x: 'Feb', y: 70 },
              { x: 'Mar', y: 78 },
            ],
          },
          {
            id: 'y2024',
            name: '2024 by quarter',
            data: [
              { x: 'Q1', y: 322 },
              { x: 'Q2', y: 356 },
              { x: 'Q3', y: 341 },
              { x: 'Q4', y: 402 },
            ],
          },
          {
            id: 'y2025',
            name: '2025 by quarter',
            data: [
              { x: 'Q1', y: 428 },
              { x: 'Q2', y: 455 },
              { x: 'Q3', y: 471 },
              { x: 'Q4', y: 512 },
            ],
          },
        ],
      },
      colors: ['#008FFB'],
      stroke: {
        width: 3,
        curve: 'smooth',
      },
      title: {
        text: 'Support tickets resolved',
        align: 'left',
      },
      subtitle: {
        text: 'Dotted points open a level: 2023, 2024 and 2025 break down by quarter.',
        align: 'left',
      },
      grid: {
        borderColor: '#e7e7e7',
      },
      yaxis: {
        title: {
          text: 'Tickets (thousands)',
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="line"
          height={380}
        />
      </div>
    </div>
  )
}

export default ApexChart

Line with Drilldown in Vue

Using ApexCharts with Vue

This Line with Drilldown example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="line"
        height="380"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Resolved',
          data: [
            { x: '2021', y: 486 },
            { x: '2022', y: 702 },
            { x: '2023', y: 1012, drilldown: 'y2023' },
            { x: '2024', y: 1421, drilldown: 'y2024' },
            { x: '2025', y: 1866, drilldown: 'y2025' },
          ],
        },
      ],
      chartOptions: {
        chart: {
          height: 380,
          type: 'line',
          toolbar: {
            show: false,
          },
        },
        drilldown: {
          enabled: true,
          breadcrumb: {
            show: true,
            rootLabel: 'All years',
          },
          series: [
            {
              id: 'y2023',
              name: '2023 by quarter',
              data: [
                { x: 'Q1', y: 214, drilldown: 'y2023-q1' },
                { x: 'Q2', y: 238 },
                { x: 'Q3', y: 259 },
                { x: 'Q4', y: 301 },
              ],
            },
            {
              id: 'y2023-q1',
              name: 'Q1 2023 by month',
              data: [
                { x: 'Jan', y: 66 },
                { x: 'Feb', y: 70 },
                { x: 'Mar', y: 78 },
              ],
            },
            {
              id: 'y2024',
              name: '2024 by quarter',
              data: [
                { x: 'Q1', y: 322 },
                { x: 'Q2', y: 356 },
                { x: 'Q3', y: 341 },
                { x: 'Q4', y: 402 },
              ],
            },
            {
              id: 'y2025',
              name: '2025 by quarter',
              data: [
                { x: 'Q1', y: 428 },
                { x: 'Q2', y: 455 },
                { x: 'Q3', y: 471 },
                { x: 'Q4', y: 512 },
              ],
            },
          ],
        },
        colors: ['#008FFB'],
        stroke: {
          width: 3,
          curve: 'smooth',
        },
        title: {
          text: 'Support tickets resolved',
          align: 'left',
        },
        subtitle: {
          text: 'Dotted points open a level: 2023, 2024 and 2025 break down by quarter.',
          align: 'left',
        },
        grid: {
          borderColor: '#e7e7e7',
        },
        yaxis: {
          title: {
            text: 'Tickets (thousands)',
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 700px;
  margin: 35px auto;
}
</style>